///Guid Generator
export function GenerateGUID() {
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0,
        v = c == "x" ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
}

///Base 64 Encode/Decode
var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
export var Base64 = {
  btoa: function btoa() {
    var input = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";

    var str = input;
    var output = "";

    for (var block = 0, charCode, i = 0, map = chars; str.charAt(i | 0) || (map = "=", i % 1); output += map.charAt(63 & block >> 8 - i % 1 * 8)) {
      charCode = str.charCodeAt(i += 3 / 4);

      if (charCode > 0xff) {
        throw new Error("'btoa' failed: The string to be encoded contains characters outside of the Latin1 range.");
      }

      block = block << 8 | charCode;
    }

    return output;
  },

  atob: function atob() {
    var input = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";

    var str = input.replace(/=+$/, "");
    var output = "";

    if (str.length % 4 == 1) {
      throw new Error("'atob' failed: The string to be decoded is not correctly encoded.");
    }
    for (var bc = 0, bs = 0, buffer, i = 0; buffer = str.charAt(i++); ~buffer && (bs = bc % 4 ? bs * 64 + buffer : buffer, bc++ % 4) ? output += String.fromCharCode(255 & bs >> (-2 * bc & 6)) : 0) {
      buffer = chars.indexOf(buffer);
    }

    return output;
  },

  isBase64: function isBase64(v, opts) {
    if (v instanceof Boolean || typeof v === "boolean") {
      return false;
    }
    if (!(opts instanceof Object)) {
      opts = {};
    }
    if (opts.hasOwnProperty("allowBlank") && !opts.allowBlank && v === "") {
      return false;
    }

    var regex = "(?:[A-Za-z0-9+\\/]{4})*(?:[A-Za-z0-9+\\/]{2}==|[A-Za-z0-9+/]{3}=)?";

    if (opts.mime) {
      regex = "(data:\\w+\\/[a-zA-Z\\+\\-\\.]+;base64,)?" + regex;
    }

    if (opts.paddingRequired === false) {
      regex = "(?:[A-Za-z0-9+\\/]{4})*(?:[A-Za-z0-9+\\/]{2}(==)?|[A-Za-z0-9+\\/]{3}=?)?";
    }

    return new RegExp("^" + regex + "$", "gi").test(v);
  }
};