"use strict";

exports.__esModule = true;
exports.ActionType = exports.ContentType = exports.MessageBuilder = undefined;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _ContentType = require("./ContentType");

var _ContentType2 = _interopRequireDefault(_ContentType);

var _ActionType = require("./ActionType");

var _ActionType2 = _interopRequireDefault(_ActionType);

var _Utils = require("../Utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DefaultMessage = {
  CurrentID: undefined,
  RoomID: undefined,
  MessageContent: {
    ActionType: undefined,
    ContentType: undefined,
    ContentValue: undefined
  }
};

function GetDefaultObject() {
  return Object.assign({}, DefaultMessage);
}

var MessageBuilder = {
  AppConnected: function AppConnected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.APP_CONNECTED;
    returnMessage.MessageContent.ContentType = _ContentType2.default.TEXT_PLAIN;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  AppDisconected: function AppDisconected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.APP_DISCONNECTED;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  HostConnected: function HostConnected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.HOST_CONNECTED;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  HostDisconnected: function HostDisconnected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.HOST_DISCONNECTED;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  AnexoPedidoMedico: function AnexoPedidoMedico(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.PEDIDO_MEDICO_ANEXO;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_BASE64;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Texto: function Texto(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.ENVIAR_TEXTO_LAUDO;
    returnMessage.MessageContent.ContentType = _ContentType2.default.TEXT_PLAIN;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Audio: function Audio(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.DITADO_AUDIO;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_BASE64;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  StateChanged: function StateChanged(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.STATE_CHANGED;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Laudar: function Laudar(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.ATALHO_ACAO_LAUDAR;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Revisar: function Revisar(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.ATALHO_ACAO_REVISAR;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  LaudarRevisar: function LaudarRevisar(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.ATALHO_ACAO_LAUDAR_REVISAR;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  ReconhecimentoSTT: function ReconhecimentoSTT(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.RECONHECIMENTO_VOZ_STT;
    returnMessage.MessageContent.ContentType = _ContentType2.default.TEXT_PLAIN;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  ComandoAssistente: function ComandoAssistente(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = (0, _Utils.GenerateGUID)();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = _ActionType2.default.COMANDO_ASSISTENTE;
    returnMessage.MessageContent.ContentType = _ContentType2.default.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  }
};

exports.MessageBuilder = MessageBuilder;
exports.ContentType = _ContentType2.default;
exports.ActionType = _ActionType2.default;